<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

// For Modals
add_ThickBox();

global $wpdb;
$table_name = $wpdb->prefix . 'mgnf_widget';


//Taken from Makitweb

// Import CSV
if (isset($_POST['btnImport']) && isset( $_POST['verField'] ) && wp_verify_nonce( $_POST['verField'], 'verify' )) {

    // File extension
    $extension = pathinfo($_FILES['import_file']['name'], PATHINFO_EXTENSION);

    // If file extension is 'csv'
    if (!empty($_FILES['import_file']['name']) && $extension == 'csv') {

        $totalInserted = 0;

        // Open file in read mode
        $csvFile = fopen($_FILES['import_file']['tmp_name'], 'r');

        fgetcsv($csvFile, 0, "\t");; // Skipping header row

        // Read file
        while (($csvData = fgetcsv($csvFile, 0, "\t")) !== FALSE) {

            $csvData = array_map("utf8_encode", $csvData);

            // Row column length
            $dataLen = count($csvData);

            // Skip row if length != 4
            if (!($dataLen == 3)) continue;

            // Assign value to variables
            $wname = sanitize_text_field(trim($csvData[0]));
            $wkey = sanitize_text_field(trim($csvData[1]));
            $wcap = sanitize_textarea_field(trim($csvData[2]));

            // Check record already exists or not
            $cntSQL = "SELECT count(*) as count FROM {$table_name} where name='" . $wname . "'";
            $record = $wpdb->get_results($cntSQL, OBJECT);


            if ($record[0]->count == 0) {

                // Check if variable is empty or not
                if (!empty($wname) && !empty($wkey) && !empty($wcap)) {

                    // Insert Record
                    $wpdb->insert($table_name, array(
                        'wname' => $wname,
                        'wkey' => $wkey,
                        'wcapabilities' => $wcap
                    ));

                    if ($wpdb->insert_id > 0) {
                        $totalInserted++;
                    }
                }
            }
        }
        echo "<h3 style='color: green;'>Total Widgets Added : " . $totalInserted . "</h3>";
    } else {
        echo "<h3 style='color: red;'>Invalid Extension</h3>";
    }
}

?>


<div class="wrap">
    <h1 style="margin-bottom: 1rem;">Magnifi Widget Settings</h1>


    <!-- Display Short Codes Available -->
    <table style="margin-bottom: 1rem;" class="widefat fixed" cellspacing="0">
        <thead>
            <tr>
                <td class="manage-column column-columnname" scope="col">Widget ID</td>
                <td class="manage-column column-columnname" scope="col">Widget Name</td>
                <td class="manage-column column-columnname" scope="col">Widget Short Code</td>
                <td class="manage-column column-columnname" scope="col">Customization</td>
            </tr>
        </thead>
        <tbody>
            <?php
            //Pull Data from mgnf_widget table
            $entries = $wpdb->get_results("SELECT * FROM " . $table_name . " ORDER BY id ASC");
            if (count($entries) > 0) {
                $count = 0;
                foreach ($entries as $entry) {
                    $id = $entry->id;
                    $name = $entry->wname;
                    echo "
                            <tr class='alternate'>
                                <td class='column-columnname' scope='col'>" . $id . "</td>
                                <td class='column-columnname' scope='col'>" . $name . "</td>
                                <td class='column-columnname' scope='col'>[magnifi id=" . $id . "] <a style='cursor: pointer;' onclick='mgnf_copy(" . $id . ")'>Copy</a></td>
                                <td class='column-columnname' scope='col'><a href='#TB_inline?&width=350&height=400&inlineId=widgetCustomize' class='thickbox' style='cursor: pointer;' onclick='mgnf_customizeWidget(" . $id . ")'>Customize</a></td>
                            </tr>
                        ";
                }
            } else {
                echo "<tr><td>No Data</td></tr>";
            }
            ?>
        </tbody>
    </table>

    <!-- User Import -->
    <form method="post" action='<?= $_SERVER['REQUEST_URI'] ?>' enctype="multipart/form-data">
        <input type="file" name="import_file">
        <input type="submit" class="button button-primary" name="btnImport" value="Import CSV">

        <?php wp_nonce_field( 'verify', 'verField' ); ?>

    </form>

</div>

<!-- Modal -->
<?php add_thickbox(); ?>
<div id="widgetCustomize" style="display:none;">
    <center><h2>Group Options</h2>
    <form>
        <table>
            <tr>
                <td align="left">Unique Identifier:</td>
                <td align="left"><input id="org_uid" type="text" name="uid" /></td>
            </tr>
            <tr>
                <td align="left">First Name:</td>
                <td align="left"><input id="org_first" type="text" name="first" /></td>
            </tr>
            <tr>
                <td align="left">Last Name:</td>
                <td align="left"><input id="org_last" type="text" name="last" /></td>
            </tr>
            <tr>
                <td align="left">Email:</td>
                <td align="left"><input id="org_email" type="email" name="email" /></td>
            </tr>
        </table>
    </form>
    <br>
    <button class="button button-primary" onclick="mgnf_createCustomShortCode()" >Create and Copy New Short Code</button><center><br>
    <p id="newShortCode"></p>
</div>

<script>
    var currentWidget = null;

    function mgnf_copy(str) {
        var el = document.createElement('textarea');
        el.value = "[magnifi id=" + str + "]";
        el.setAttribute('readonly', '');
        el.style = {
            position: 'absolute',
            left: '-9999px'
        };
        document.body.appendChild(el);
        el.select();
        document.execCommand('copy');
        document.body.removeChild(el);
    }

    function mgnf_customizeWidget(id) {
        currentWidget = parseInt(id);
        document.getElementById("newShortCode").innerHTML = "[magnifi id=" + currentWidget + "]";
    }

    function mgnf_createCustomShortCode(){
        var shortcode = currentWidget;
        if(!document.getElementById("org_uid").value == ""){
            shortcode = shortcode + " uid=" + document.getElementById("org_uid").value;
        }
        if(!document.getElementById("org_first").value == ""){
            shortcode = shortcode + " first=" + document.getElementById("org_first").value;
        }
        if(!document.getElementById("org_last").value == ""){
            shortcode = shortcode + " last=" + document.getElementById("org_last").value;
        }
        if(!document.getElementById("org_email").value == ""){
            shortcode = shortcode + " email=" + document.getElementById("org_email").value;
        }
        document.getElementById("newShortCode").innerHTML = "[magnifi id=" + shortcode + "]";
        mgnf_copy(shortcode);
    }
</script>